# Examples

The `examples` directory contains examples of different use cases and
error scenarios.

## Anatomy of an Example

Each example is supposed to contain at least

* a `README.md` file describing the example's intent and how to
  execute it,
* a driver shell script for executing and testing (!) the complete
  example return a zero exit code in case of success and a non-zero
  return status in case of failure, and
* example-specific configuration files and helper scripts as required.

Re-usable shell scripts shared across multiple examples are kept in
the `scripts` sub-directory.  Compiled executables are taken from
`../build-dir`.

## TLS Certificates

### Generating Keys and Certificates

As in any TLS server, the server needs a (CA-signed) certificate and a
matching private key.

The client (and server, in case of mutual authentication can verify
their peer's certificate if the (possibly self-signed) certificate of
the issuing CA is available.  You can generate all this using OpenSSL.

`../ssl/generate_ca_and_selfsigned_cert.sh` is used to generate the
keys and certificates used by the current set of examples.


### We are cutting some corners ...

To keep it simple, we use the very same certificates for multiple
server instances in some examples.  In real life, these key servers
would most certainly run on different hosts requiring different
certificates.
